#! /usr/bin/perl -w
#
# To update the inp2n.newdev.gen
# if the information is already there, do nothing
# otherwise, update
#
# Usage:
# modify.inp2n.c.pl devname
#
# July 9,2003
# Bo Hu   hubo@ee.washington.edu
# Electrical Engineering 
# The University of Washington
#
# updated: July 14,2003
#
if( $#ARGV < 0 )
{ die "***input format error***\nUsage: \n     modify.inp2n.c.pl devicename \nProgram exits\n";}
if(defined($ENV{SPICEDIR}))
{
  $dir = $ENV{SPICEDIR} . "/src/lib/inp";
}
else
{
 die "enviroment variable SPICEDIR undefined, program exits \n";
}
$dev = $ARGV[0];
# $dir = $ARGV[1];

$gen1 = $dir . "/inp2n.newdev.gen";
$out1 = $dir . "/inp2n.tmp.gen";

open(FIN1,$gen1) or die "cannot open file $gen1\n";
open(FOUT1,">$out1") or die "cannot write file $out1\n";

$updated = 0; #if file already updated, $updated will be 1;
#update config.newdev.gen1
while(<FIN1>)
{
  chomp;
  $line = $_;
  if($line =~ /\s+&& thismodel->INPmodType != INPtypelook\(\"($dev)\"\)/)
  {
    print STDERR "device $dev already updated in file $gen1\n";
    close FIN1; close FOUT1; unlink $out1; 
    $updated = 1;
    last;
  }
  print FOUT1 "$line\n";
}
if($updated == 0)
{
  print FOUT1 "\t\t\t\t&& thismodel->INPmodType != INPtypelook(\"$dev\")\n";
  close FIN1; close FOUT1; unlink $gen1;
  rename $out1, $gen1;
}

print STDERR "$gen1 has been updated. (included in inp2n.c)\n"






