/****************************************************************
File generated by Device Model Compiler: BMAC
Author: Bo Wan, 2003
Copyright 2003(c) Mixed-Signal CAD lab. University of Washington.
All rights reserved.
****************************************************************/

//
// fast interpolation using biliner
// assume x or y are uniformly seperated or log seperated
//
#include <math.h>
#include "genCommon.h"

double
log_interpolate_bilinear(TableList* curr,double u, double v) {
	int ip,iq;
    double y1,y2,y3,y4;
    double tt,tu;
	int ipInc,iqInc;

    if (u>(curr->_x)[curr->_m-1]) {
		u=(curr->_x)[curr->_m-1];
		#ifdef DEBUG
		printf("ERROR: out of range! u:%-.15g > x[m-1]:%-.15g", u, (curr->_x)[curr->_m-1]);
		#endif
	}
    if (u<(curr->_x)[0]) {
		u=(curr->_x)[0];
		#ifdef DEBUG
		printf("ERROR: out of range! u:%-.15g < x[0]:%-.15g", u, (curr->_x)[0]);
		#endif
	}
    if (v>(curr->_y)[curr->_n-1]) {
		v=(curr->_y)[curr->_n-1];
		#ifdef DEBUG
		printf("ERROR: out of range! v:%-.15g > y[n-1]:%-.15g", v, (curr->_y)[curr->_n-1]);
		#endif
	}
    if (v<(curr->_y)[0]) {
		v=(curr->_y)[0];
		#ifdef DEBUG
		printf("ERROR: out of range! v:%-.15g < y[0]:%-.15g", v, (curr->_y)[0]);
		#endif
	}

	if (curr->_x_logFlag) {
		ip = log(fabs(u/curr->_x[0]))/curr->_x_logStep;
	} else {
		ip = (int) ( (u-(curr->_x)[0])/(((curr->_x)[curr->_m-1]-(curr->_x)[0])/(curr->_m-1)) );
	}
	if (curr->_y_logFlag) {
		iq = log(fabs(v/curr->_y[0]))/curr->_y_logStep;
	} else {
		iq = (int) ( (v-(curr->_y)[0])/(((curr->_y)[curr->_n-1]-(curr->_y)[0])/(curr->_n-1)) );
	}

    y1 = (curr->_table)[ip][iq];
    ipInc = (ip+1>=curr->_m) ? ip : ip+1;
    iqInc = (iq+1>=curr->_n) ? iq : iq+1;
    y2 = (curr->_table)[ipInc][iq];
    y3 = (curr->_table)[ipInc][iqInc];
    y4 = (curr->_table)[ip][iqInc];

	if (ipInc == ip) tt=0;
    else tt = (u-(curr->_x)[ip])/((curr->_x)[ipInc]-(curr->_x)[ip]);
	if (iqInc == iq) tu=0;
    else tu = (v-(curr->_y)[iq])/((curr->_y)[iqInc]-(curr->_y)[iq]);

    return ( (1-tt)*(1-tu)*y1 + tt*(1-tu)*y2 + tt*tu*y3 + (1-tt)*tu*y4 );
  }
 
